/*===================================
		Copyright Yakibomb
*///=================================

class ::VSConds_Base
{
	condition = null;
	entity = null;
	entity_scope = null;
	provider = null;
	provider_scope = null;
	
	use_think_script = false;
	think_ent = null;
	think_ent_scope = null;
	
//bits organized in compiler step vsconds_conditions_compiler.nut
	removedByDeath = true;
	removedByResupply = true;
	removedByTeamChange = true;
	removedByClassChange = true;
	removedByCommand = true;
	addcondIgnoreDeathState = false;
	settingsBits = 0;
	
	constructor(addcond,c_entity,c_provider=worldspawn) {
		this.condition = condition;
		
		entity = c_entity;
		this.entity = c_entity;
		if ( entity && entity.IsValid() && entity.ValidateScriptScope() ) this.entity_scope = entity.GetScriptScope();
		
	
		if ( c_provider != worldspawn 
		  && type(c_provider) == "instance" && VSCONDS_IsEntValid(c_provider) ) { }
		else if ( c_provider == null ) { c_provider = worldspawn; }
		else if ( c_provider == worldspawn && c_provider != c_entity ) { c_provider = worldspawn; }
		else c_provider = c_entity;
		
		provider = c_provider;
		this.provider = c_provider;
		if ( c_provider.ValidateScriptScope() ) this.provider_scope = provider.GetScriptScope();
		
	// Conditions Compiler sets this to true if `Think()` function is added to new class
		this.use_think_script = use_think_script;
		
	// Creates logic_relay entity and applies think script.
	// Using logic_relay because it clears on roundspawn.
		if ( use_think_script 
		  && addcond ) {
			
			local thinkentname = format("VSConds_%d_%d_%d",entity.entindex(),condition,provider.entindex());
			think_ent = SpawnEntityFromTable("logic_relay", {
				targetname = thinkentname,
				spawnflags = 1,
			})
			this.think_ent = think_ent;
			
			think_ent.ValidateScriptScope();
			think_ent_scope = think_ent.GetScriptScope();
			this.think_ent_scope = think_ent_scope;
			
			
			think_ent_scope["condition"] <- condition;
			think_ent_scope["condition_name"] <- condition_name;
			think_ent_scope["entity"] <- entity;
			think_ent_scope["entity_scope"] <- entity_scope;
			think_ent_scope["provider"] <- provider;
			think_ent_scope["provider_scope"] <- provider_scope;
			
			think_ent_scope["use_think_script"] <- use_think_script;
			think_ent_scope["think_ent"] <- think_ent;
			think_ent_scope["think_ent_scope"] <- think_ent_scope;
			
			think_ent_scope["removedByDeath"] <- removedByDeath;
			think_ent_scope["removedByResupply"] <- removedByResupply;
			think_ent_scope["removedByTeamChange"] <- removedByTeamChange;
			think_ent_scope["removedByClassChange"] <- removedByClassChange;
			think_ent_scope["removedByCommand"] <- removedByCommand;
			think_ent_scope["settingsBits"] <- settingsBits;
			
			think_ent_scope["RemoveThink"] <- this.RemoveThink;
			think_ent_scope["PauseThink"] <- this.PauseThink;
			think_ent_scope["UnpauseThink"] <- this.UnpauseThink;
			
			think_ent_scope["Think"] <- this.Think;
			AddThinkToEnt(think_ent,"Think");
		}
	}
	
	function AddCond() { } 
	function RemoveCond() { } 
	function Think() { } 
	
	function PauseThink() { think_ent.AddEFlags(EFL_NO_THINK_FUNCTION); }
	function UnpauseThink() { think_ent.RemoveEFlags(EFL_NO_THINK_FUNCTION); }
	function RemoveThink() {
		SetPropString(think_ent, "m_iszScriptThinkFunction", "");
		//DoEntFire(think_ent, "Trigger", "", 0.0, worldspawn, worldspawn);
	}
}

::VS_COND_BASE <- VSConds_Base;