/*===================================
		Copyright Yakibomb
*///=================================


function VSCONDS_ADD_CONDITION(CONDITION_NAME) {
	
	VSCOND_COND_PROCESS_ORDER.append(CONDITION_NAME);
	
	local delay_add = VSCOND_COND_PROCESS_ORDER.len() * 0.01;
	EntFireByHandle(worldspawn,"RunScriptCode","VSCONDS_PROCESS_CONDITION(\""+CONDITION_NAME+"\")",delay_add,worldspawn,worldspawn)
}



function VSCONDS_PROCESS_CONDITION(CONDITION_NAME) {
// Some checks
// First if it's a string, else ERROR
	local VS_CONDITION_FUNC_NAME;
	local VS_CONDITION_FUNC;
	
	if ( type(CONDITION_NAME) == "string" 
	  && typeof(ROOT[CONDITION_NAME]) == "class" ) { 
		VS_CONDITION_FUNC_NAME = "VSCONDFUNC_" + CONDITION_NAME;
		VS_CONDITION_FUNC = ROOT[CONDITION_NAME];
	}
	else {
		local finder = VSCOND_COND_PROCESS_ORDER.find(CONDITION_NAME);
		switch (finder) {
			case null : break;
			default : VSCOND_COND_PROCESS_ORDER.remove(finder); break;
		}
		
		throw "ERROR in VSCONDS : VSCond name is not a string, and/or it doesn't exist in roottable as a class";
	}
	
// Last if vscond already exists, cleanup and rearrange data
	local array_index = VSCOND_COND_NAMES.find(CONDITION_NAME);
	if ( array_index ) {
		printl(format("VSCONDS : Not an error, but %s already exists. Running VSCONDS_CLEANUP()...",CONDITION_NAME));
		
		VSCONDS_CLEANUP();
	
		VSCOND_COND_NAMES.remove(array_index);
		VSCOND_COND_FUNC.remove(array_index);
		
		foreach(key, cond in VSCOND_COND_NAMES) {
			if ( key < array_index ) continue
			ROOT[cond] <- key;
		//	printl(key + " " + cond);
		}
	}
// Copies over function before converting to constant

	ROOT[VS_CONDITION_FUNC_NAME] <- VS_CONDITION_FUNC;
	VSCOND_COND_FUNC.append(VS_CONDITION_FUNC);
	VSCOND_COND_NAMES.append(CONDITION_NAME);
	
	local COND_ID = VSCOND_COND_NAMES.len() - 1;

	delete ROOT[CONDITION_NAME];
	ROOT[CONDITION_NAME] <- COND_ID;
	
// Begins to implement info to copied function name
	ROOT[VS_CONDITION_FUNC_NAME]["condition"] <- ROOT[CONDITION_NAME];
	ROOT[VS_CONDITION_FUNC_NAME]["condition_name"] <- CONDITION_NAME;
	
	local base_function_think = VSConds_Base["Think"];
	local condition_func = ROOT[VS_CONDITION_FUNC_NAME];
	foreach ( key, kv in condition_func )
	{
		if ( key == "condition" ) continue
		
		if ( key == "Think" ) {
			if ( kv != base_function_think ) {
				ROOT[VS_CONDITION_FUNC_NAME]["use_think_script"] <- true;
			}
			else 
				ROOT[VS_CONDITION_FUNC_NAME]["use_think_script"] <- false;
		}
		
		ROOT[VS_CONDITION_FUNC_NAME][key] <- kv;
	}
//Sets up condition states
//states are in vsconds_constants.nut
	local bits = 0;
	foreach ( key, kv in condition_func )
	{
		if ( key == "removedByDeath"
		  && kv == true )
			bits += VSCONDS_BASE_REMOVEABLE_BY_DEATH;
		else if ( key == "removedByResupply"
		  && kv == true )
			bits += VSCONDS_BASE_REMOVEABLE_BY_RESUPPLY;
		else if ( key == "removedByTeamChange"
		  && kv == true )
			bits += VSCONDS_BASE_REMOVEABLE_BY_TEAMCHANGE;
		else if ( key == "removedByClassChange"
		  && kv == true )
			bits += VSCONDS_BASE_REMOVEABLE_BY_CLASSCHANGE;
		else if ( key == "removedByCommand"
		  && kv == true )
			bits += VSCONDS_BASE_REMOVEABLE_BY_COMMAND;
		else if ( key == "addcondIgnoreDeathState"
		  && kv == true )
			bits += VSCONDS_BASE_ADDCOND_IGNORE_DEATH;
	}
	ROOT[VS_CONDITION_FUNC_NAME]["settingsBits"] <- bits;
// end condition states setup

	printl("AddVSCond entry \""+CONDITION_NAME + "\" was Successful!");

	if ( CONDITION_NAME == "VS_COND_BASE" ) return;
	
	local finder = VSCOND_COND_PROCESS_ORDER.find(CONDITION_NAME);
	if (finder == null ) return;
	VSCOND_COND_PROCESS_ORDER.remove(finder);
}
