/*===================================
		Copyright Yakibomb
*///=================================

function VSCONDS_CLEANUP()
{
// Prevents running if cleanup already happening
	if ( VSCONDS_CLEANUP_RUNNING ) return printl("VSCONDS CLEANUP already running");
	::VSCONDS_CLEANUP_RUNNING <- true;
	
	printl("VSCONDS CLEANUP FUNCTION RUNNING");
	
// Pauses big think
	if ( addvsconds ) addvsconds.AddEFlags(EFL_NO_THINK_FUNCTION);
	
// Collects attachments and conditions on ents with them
	local list_attach_parent = {};
	local list_attach_child = {};
	local list_ent_table = {};
	
	foreach ( key, value in ROOT )
	{
		if ( typeof(value) == "array" ) {
			if ( startswith(key, "VSCOND_ATTACH_PARENT") )
				list_attach_parent[key] <- value;
			else if ( startswith(key, "VSCOND_ATTACH_CHILD") )
				list_attach_child[key] <- value;
		}
		else if ( typeof(value) == "table" && startswith(key, "VSCOND_TABLE_") ) {
			list_ent_table[key] <- value;
		}
	}
	
// Removes child attachments from parent ents (i.e. particles, props, etc)
	foreach ( key, value in list_attach_child )
	{
		foreach ( index, attachment in value ) {
			if ( attachment && attachment.IsValid() ) { attachment.Kill(); }
		}
		delete ROOT[key];
	}
	foreach ( key, value in list_attach_parent )
	{
		delete ROOT[key];
	}
	
// Fires RemoveVSCond() on ents with vsconds applied
	foreach ( key, value in list_ent_table )
	{
		local ent_index = split(key,"_");
		ent_index = ent_index[2].tointeger();
		VSCONDS_RemoveThinkToCond_ALL(ent_index);
		
		local ent_data = ROOT[key];
		local ent = ent_data[VSCond_MAX_Conditions];
		local ent_validate = ent_data[VSCond_MAX_Conditions + 1];
		
		if ( ent == ent_validate 
		  && ent.IsValid() )
		{
			foreach (condition,duration in ent_data ) {
				if ( condition >= VSCond_MAX_Conditions ) continue
				ent.RemoveVSCond(condition, true);
				local finder = VSCOND_ENTS_UNDER_CONDS.find(ent_data);
				if (finder) VSCOND_ENTS_UNDER_CONDS.remove(finder);
			}
		}
		delete ROOT[key];
	}
	
// Deletes invisible wearables
	foreach ( key, wearable in VSCOND_HIDDEN_WEARABLES ) {
		if ( wearable && wearable.IsValid() ) wearable.Kill();
	}
	
// Resets params to factory state
	VSCONDS_RESET_PARAMS()
	
// Unpauses big think
	if ( addvsconds ) addvsconds.RemoveEFlags(EFL_NO_THINK_FUNCTION);
	
// Restores being able to run this function
	EntFireByHandle(worldspawn,"RunScriptCode","::VSCONDS_CLEANUP_RUNNING <- false",1.0,worldspawn,worldspawn);
	printl("VSCONDS CLEANUP FUNCTION FINISHED!");
	
}