/*===================================
		Copyright Yakibomb
*///=================================

/*===================================
	NOTE: Make sure your script is compiled into root table to prevent errors!
	IncludeScript("addvscond/conditions/EXAMPLE_readme.nut", ROOT);	
*///===================================

/*===================================
- Available variables to read from this class
- Writing to these variables in the class might cause undesired effects

	condition_name == condition's string name,
	condition == condition's ID number,

	entity == entity handle with applied condition,
	entity_scope == Entity's scope,

	provider == provider handle (worldspawn by default),
	provider_scope == Provider's scope,
	
	use_think_script == reads `true` if Think() function available in extended class,
	think_ent == Condition's think script entity,
	think_ent_scope = think script entity's scope.

*//*===================================
- Extended functions in this class
- Write your code in these functions!
	Think()						//optional
	AddCond()	
	RemoveCond()
	
- These are here for easy access, might be unnecessary but hey they're here.
	PauseThink()	//Pauses think script to be started later
	UnpauseThink()	//Unpauses think script
	RemoveThink()	//Removes think script. Can be used within same think script.
	
*///===================================


// VS_COND_EXAMPLE is the name of the function, which gets converted into a number ID on compile.

// When you go to add the condition to an entity, call it with:
// ent.AddVSCond(VS_COND_EXAMPLE)

// "VSConds_Base" class found under "addvscond/code/compiler/vsconds_conditions_base.nut"

class VS_COND_EXAMPLE extends VSConds_Base	//must extend from VSConds_Base
{
/*	These are conditions settings you can use to check entity states.
	NOTE: These are the default values.
	
	removedByDeath = true;			//Does death remove the condition? (checks if m_lifeState != 0 )
	removedByResupply = true;		//Players only: Does resupply remove the condition?
	removedByTeamChange = true;		//Players only: Does changing teams remove the condition?
	removedByClassChange = true;	//Players only: Does changing tfclasses remove the condition?
	removedByCommand = true;		//Can RemoveVSCond() clear this condition?
	addcondIgnoreDeathState = false;	// Can AddVSCond() still apply condition when target is considered dead? *Useful for Engie buildings being ignored by bots when netprop "m_lifeState" = 1.
*/
	
//Place your code here for AddCond here
//This one prints all available key and values in chat
	function AddCond() {
		local color_RED = "\x07FF3F3F";
		ClientPrint(null,3, color_RED+" -> AddCond() (Check Console Log)");
		
	//Prints all available keys and what they hold
		printl("--->> These following are the variables you can use within VSConds_Base class:");
		foreach (useable_key,prints in this)
			printl(useable_key + " | " + prints);
		
	// Example of how to put values into Think()...
	// ...by putting them into the think ent's scope!
	// This saves current server time. We'll use it to find how long the condition lasted before removing it!
		think_ent_scope.time_added <- Time();
	
	// end AddCond()
		printl("\nEnd AddCond()")
	}


//Put your OPTIONAL think script here
//Creates a separate entity to think for your entity with condition
//If "function Think()" is absent, doesn't create the separate entity.
	function Think() {
	//Simply prints a message in console which ent is thinking, as well as condition number.
		printl(format("%s is thinking!\n Condition Name: %s\n Condition ID: %d",think_ent.tostring(),condition_name,condition));
		//Note: `think_ent` is the handle of the thinking entity. Can also use `self`.

		return 1;
	}
	
//Place your code here for RemoveCond here
//This one prints duration before expiring here
	function RemoveCond() {
		local time_added = think_ent_scope.time_added;
		local duration_before_removed = Time() - time_added;
		
		local string = format("%s from %s lasted for: %fs",condition_name, entity.tostring(),duration_before_removed);
		ClientPrint(null,3,string);

		local color_RED = "\x07FF3F3F";
		ClientPrint(null,3, color_RED+" -> RemoveCond()");
	}
}


/*==================================================================
// Use function VSCONDS_ADD_CONDITION("mysupervscond") at the bottom to auto-include a condition
// MUST be in quotes--be string format + class function.
*///================================================================
	VSCONDS_ADD_CONDITION("VS_COND_EXAMPLE");