/*===================================
		Copyright Yakibomb
*///=================================

/*
	VS_COND_AIRFLOW
	- Player has less gravity and more air control.
	If player jumps and/or is in the air, the condition removes itself a brief moment after.
	- Only works on players.
*/

class VS_COND_AIRFLOW extends VSConds_Base
{
	//We consider this a buff, so it shouldn't be removed upon touching resupply
	removedByResupply = false;	//`false` prevents removal on resupply
	
	
	function AddCond() { 
	//Add particle. This is automatically deleted when condition ends.
		VSCONDS_CreateTeamParticle(condition,provider,entity,entity.GetOrigin(),"utaunt_snowflakesaura_rings")
	
	//Variables for Think() entity's scope
		think_ent_scope["JumpExpireTimer_Enabled"] <- false;
		think_ent_scope["JumpExpireTimer"] <- 60;

	//Filter out non-player entities.
		if ( entity.GetClassname() != "player" ) return;
		
	//Add attributes to player only
		entity.AddCondEx(32, -1, provider)
		entity.AddCustomAttribute("major increased jump height",1.6,-1)
		entity.AddCustomAttribute("cancel falling damage",1,-1)
		entity.AddCustomAttribute("increased air control",2.4,-1)
		entity.SetGravity(0.5)
	}
	
	function Think() {
	//Define variables
		local think_scope = self.GetScriptScope();
		local JumpExpire_Flag = think_scope["JumpExpireTimer_Enabled"];
		
	//When player is off ground, enable expire timer
		if ( JumpExpire_Flag == false && entity.GetFlags() & FL_ONGROUND )
			think_scope["JumpExpireTimer_Enabled"] <- true;
		
	//When player is truly off the ground, start the countdown
		if ( JumpExpire_Flag ) {
			think_scope["JumpExpireTimer"] -= 1;
			
		//And move condition when timer ends
			if ( think_scope["JumpExpireTimer"] <= 0 ) entity.RemoveVSCond(condition);
		}
		return 0.1;
	} 
	
	function RemoveCond() {
		
	//Filter out non-player entities.
		if ( entity.GetClassname() != "player" ) return;
		
	//Add attributes
		entity.SetGravity(0)
		entity.RemoveCond(32)
		entity.RemoveCustomAttribute("major increased jump height")
		entity.RemoveCustomAttribute("increased air control")
		entity.RemoveCustomAttribute("cancel falling damage")
	}
}
	VSCONDS_ADD_CONDITION("VS_COND_AIRFLOW");