/*===================================
		Copyright Yakibomb
*///=================================

/*
	VS_COND_INKED
	- Entity becomes colorless. Has basic support for wet condition.
	- Works on all entities.
*/

class VS_COND_INKED extends VSConds_Base
{
	function AddCond() { 
		if (provider.GetTeam() == entity.GetTeam() ) entity.ExtinguishPlayerBurning();
		else VSCONDS_Color(entity,0,0,0);
	}
	
	function Think() {
		if ( entity && provider
		  && entity.IsValid() && provider.IsValid()
		  && provider.GetTeam() == entity.GetTeam() ) RemoveThink();
		
		if ( entity && entity.IsValid()
		  && entity.IsPlayer()
		  && entity.CanGetWet() )
		{
			entity.SetWaterLevel(1);
		}
		
		return 1;
	}
	
	function RemoveCond() {
		
		if ( entity.IsPlayer() && !entity.CanGetWet() ) entity.SetWaterLevel(0);
		
		VSCONDS_Color(entity,255, 255, 255);
	}
}
	VSCONDS_ADD_CONDITION("VS_COND_INKED");