/*===================================
		Copyright Yakibomb
*///=================================

/*
	VS_COND_POWERPLAY
	- Player becomes godlike!
	- Only works on players.
*/

class VS_COND_POWERPLAY extends VSConds_Base	//must extend VSConds_Base
{
	//We consider this a buff, so it shouldn't be removed upon touching resupply
	removedByResupply = false;	//`false` prevents removal on resupply
	
	function AddCond() { 
	
	//Create a burning effect on the player using trigger_particle.
		local RED_Particle = "burningplayer_red";
		local BLU_Particle = "burningplayer_blue";
		local NOTEAM_Particle = "burningplayer_rainbow";
		
		VSCONDS_CreateTeamParticleDrip(condition,provider,entity,entity.GetOrigin(), RED_Particle, BLU_Particle, NOTEAM_Particle)
		
	//Create a teleporter ring effect at player origin using trigger_particle.
		RED_Particle = "player_recent_teleport_red";
		BLU_Particle = "player_recent_teleport_blue";
		NOTEAM_Particle = "player_recent_teleport_red";
		
		VSCONDS_CreateTeamParticle(condition,provider,entity,entity.GetOrigin(), RED_Particle, BLU_Particle, NOTEAM_Particle)

	//Filter out non-player entities. Stops script if it catches non-player ent.
		if ( entity.GetClassname() != "player" ) return;
		
	//Add conditions to player to make them godlike
		entity.AddCond(TF_COND_INVULNERABLE_HIDE_UNLESS_DAMAGED);
		entity.AddCond(TF_COND_CRITBOOSTED_FIRST_BLOOD);
		entity.AddCond(TF_COND_BULLET_IMMUNE);
		entity.AddCond(TF_COND_BLAST_IMMUNE);
		entity.AddCond(TF_COND_FIRE_IMMUNE);
		entity.AddCond(TF_COND_HALLOWEEN_SPEED_BOOST);
		entity.AddCond(TF_COND_HALLOWEEN_QUICK_HEAL);
		entity.AddCond(TF_COND_RUNE_KING);
	}
	
	function RemoveCond() {
	//Stops all particles on player. Note I said ALL.
		VSCONDS_StopParticle(entity);
		//Commented this out because this is what the above function sends to our entity:
		//EntFireByHandle(entity, "DispatchEffect", "ParticleEffectStop", 0.0, worldspawn, worldspawn);
		
	//Filter out non-player entities. Stops script if it catches non-player ent.
		if ( entity.GetClassname() != "player" ) return;
		
	//Remove conditions
		entity.RemoveCond(TF_COND_INVULNERABLE_HIDE_UNLESS_DAMAGED);
		entity.RemoveCond(TF_COND_CRITBOOSTED_FIRST_BLOOD);
		entity.RemoveCond(TF_COND_BULLET_IMMUNE);
		entity.RemoveCond(TF_COND_BLAST_IMMUNE);
		entity.RemoveCond(TF_COND_FIRE_IMMUNE);
		entity.RemoveCond(TF_COND_HALLOWEEN_SPEED_BOOST);
		entity.RemoveCond(TF_COND_HALLOWEEN_QUICK_HEAL);
		entity.RemoveCond(TF_COND_RUNE_KING);
	}
}
	VSCONDS_ADD_CONDITION("VS_COND_POWERPLAY");