/*===================================
		Copyright Yakibomb
*///=================================

/*
	VS_COND_TEAMSWAP
	- Entity swaps teams based off provider's team for the duration.
	- Works on all entities.
*/

// Creates a function specifically for this condition
// Swap teams based on provider
// If provider is not input in, it defaults to applied ent's team
function vsconds_swapteam(entity, newteam) {
	
	local newskin = newteam == 2 ? 0 : 1;
	
	if ( entity.GetClassname() == "player" )
		entity.ForceChangeTeam(newteam, true);
	else 
		entity.SetTeam(newteam);
	
	if ( HasProp(entity, "m_nSkin") ) entity.SetSkin(newskin);
	
//Collects child ents parented on entity
	local child_list = VSCONDS_CollectChildOnParent(entity, false);
	
	foreach (child in child_list)
	{
		child.SetTeam(newteam);
		if ( HasProp(child, "m_nSkin") ) child.SetSkin(newskin);
	}
}


class VS_COND_TEAMSWAP extends VSConds_Base
{
	function AddCond() {
	// save original team to entity's scope, for reverting team in RemoveCond()
		entity_scope.vscond_original_team <- entity.GetTeam();
		
	//fixup newly switched team
	//If provider's team is or less than 2, set to 3. Otherwise just default to 2
		local newteam = provider.GetTeam() <= 2 ? 3 : 2;
	
		vsconds_swapteam(entity, newteam);
	}
	
	function RemoveCond() {
		vsconds_swapteam(entity, entity_scope.vscond_original_team);
	}
}

	VSCONDS_ADD_CONDITION("VS_COND_TEAMSWAP");